System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _decorator, Component, ConfigurableConstraint, director, Input, input, KeyCode, math, RigidBody, Vec3, car, key_status, _dec, _class, _crd, ccclass, property, main;

  function _reportPossibleCrUseOfcar(extras) {
    _reporterNs.report("car", "./car", _context.meta, extras);
  }

  function _reportPossibleCrUseOfkey_status(extras) {
    _reporterNs.report("key_status", "./car", _context.meta, extras);
  }

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      ConfigurableConstraint = _cc.ConfigurableConstraint;
      director = _cc.director;
      Input = _cc.Input;
      input = _cc.input;
      KeyCode = _cc.KeyCode;
      math = _cc.math;
      RigidBody = _cc.RigidBody;
      Vec3 = _cc.Vec3;
    }, function (_unresolved_2) {
      car = _unresolved_2.car;
      key_status = _unresolved_2.key_status;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "7f5bcTlBwFC1LZ7vhfO+dMp", "main", undefined);

      __checkObsolete__(['__private', '_decorator', 'Component', 'ConfigurableConstraint', 'director', 'EventKeyboard', 'Input', 'input', 'KeyCode', 'math', 'Node', 'physics', 'RigidBody', 'Vec3']);

      ({
        ccclass,
        property
      } = _decorator);

      _export("main", main = (_dec = ccclass('main'), _dec(_class = class main extends Component {
        constructor(...args) {
          super(...args);
          // CAR
          this.car = new (_crd && car === void 0 ? (_reportPossibleCrUseOfcar({
            error: Error()
          }), car) : car)();
          this.key_status = new (_crd && key_status === void 0 ? (_reportPossibleCrUseOfkey_status({
            error: Error()
          }), key_status) : key_status)();
        }

        start() {
          this.car.carNode = director.getScene().getChildByPath("CarPhisycs");
          this.car.wheel1lNode = director.getScene().getChildByPath("CarPhisycs/wheels").children;
          this.car.hubNode = director.getScene().getChildByPath("CarPhisycs/hub").children;
          input.on(Input.EventType.KEY_DOWN, this.KeyDown, this);
          input.on(Input.EventType.KEY_UP, this.KeyUp, this);
        }

        setDrivingSpeed(speed) {
          this.car.wheel1lNode.forEach(wheel => {
            let newSpeed = speed * 10;
            let com = wheel.getComponent(ConfigurableConstraint);

            if (com) {
              com.angularDriverSettings.targetVelocity.x = newSpeed;
              com.angularDriverSettings.targetVelocity = com.angularDriverSettings.targetVelocity;
            }
          });
        }

        setDrivingForce(strength) {
          this.car.wheel1lNode.forEach(wheel => {
            const com = wheel.getComponent(ConfigurableConstraint);

            if (com) {
              com.angularDriverSettings.strength = strength;
            }
          });
        }

        stopAuto() {
          this.car.wheel1lNode.forEach(wheel => {
            const com = wheel.getComponent(RigidBody);

            if (com) {
              com.clearState();
              this.setDrivingSpeed(0);
              this.setDrivingForce(0);
            }
          });
        }

        KeyDown(key) {
          if (key.keyCode === KeyCode.ARROW_UP) {
            this.key_status.gearUp = true;
          }

          if (key.keyCode === KeyCode.ARROW_DOWN) {
            this.key_status.gearDown = true;
          }

          if (key.keyCode === KeyCode.ARROW_LEFT) {
            this.key_status.left = true;
          }

          if (key.keyCode === KeyCode.ARROW_RIGHT) {
            this.key_status.right = true;
          }
        }

        KeyUp(key) {
          if (key.keyCode === KeyCode.ARROW_UP) {
            this.key_status.gearUp = false;
            this.stopAuto();
            this.key_status.currentDirection = "";
          }

          if (key.keyCode === KeyCode.ARROW_DOWN) {
            this.key_status.gearDown = false;
            this.stopAuto();
            this.key_status.currentDirection = "";
          }

          if (key.keyCode === KeyCode.ARROW_LEFT) {
            this.key_status.left = false;
          }

          if (key.keyCode === KeyCode.ARROW_RIGHT) {
            this.key_status.right = false;
          }
        }

        setSteeringAngle(steeringDelta) {
          this.car.hubNode.forEach(hub => {
            let z = 0;

            if (hub.name == "1left" || hub.name == "1right") {
              let smoothedSteeringAngle = hub.getComponent(ConfigurableConstraint).angularDriverSettings.targetOrientation.z;
              z = math.lerp(smoothedSteeringAngle, steeringDelta, 0.08);
              let com0 = hub.getComponent(ConfigurableConstraint);
              com0.angularDriverSettings.targetOrientation = new Vec3(com0.angularDriverSettings.targetOrientation.x, com0.angularDriverSettings.targetOrientation.y, z);
              console.log(com0.angularDriverSettings.targetOrientation);
            }
          });
        }

        update(dt) {
          if (this.key_status.left) {
            this.setSteeringAngle(30);
          }

          if (this.key_status.right) {
            this.setSteeringAngle(-30);
          }

          if (this.key_status.gearUp) {
            this.setDrivingSpeed(100);
            this.setDrivingForce(500);
          }

          if (this.key_status.gearDown) {
            this.setDrivingSpeed(-100);
            this.setDrivingForce(500);
          }
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=c42cc8b79f0c35d46b74ae861dcc1ad80a38b2e0.js.map